#ifndef BOOST_DATABASE_ROW_HPP_INCLUDED
#define BOOST_DATABASE_ROW_HPP_INCLUDED

#include "detail/convert_field.hpp"

#include "field.hpp"

#include <boost/shared_ptr.hpp>

namespace boost {

	namespace db {

		namespace detail {

			struct abstract_row_set;
		}

		struct row {

			row(shared_ptr<detail::abstract_row_set>, unsigned int);

			unsigned int index;

			template <typename Type, typename Key> void get(Type& f, const Key& k) const {

				f = get<Type>(k);
			}

			template <typename Type, typename Key> Type get(const Key& k) const {

				return detail::convert_field<Type>(get_field(k));
			}

			field get_field(unsigned int index) const;

			field get_field(const std::string& name) const;

		private:

			shared_ptr<detail::abstract_row_set> pimpl;
		};
	}
}

#endif /* BOOST_DATABASE_ROW_HPP_INCLUDED */
