
#include <boost/database/postgresql/connect.hpp>

#include <iostream>
#include <exception>

int
main() {

	try {

		namespace db = boost::db;

		db::database d = db::postgresql::connect("dbname = test user = test password = test");

		const db::row_set rows = d.query("SELECT * FROM test");

		for(db::row_set::const_iterator i = rows.begin(); i != rows.end(); ++i) {

			std::cout << i->get<int>("id") << std::endl;
		}
	}
	catch (const std::exception& e) {

		std::cout << "err: " << e.what() << std::endl;
	}

	return 0;
}